package com.atguigu.auth.controller;

import com.atguigu.auth.service.SysUserService;
import com.atguigu.common.result.Result;
import com.atguigu.model.system.Login;
import com.atguigu.model.system.SysUserinfo;
import com.atguigu.vo.system.LoginVo;
import io.swagger.annotations.Api;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 后台登录登出
 * </p>
 */
@Api(tags = "后台登录管理")
@RestController
@RequestMapping("/admin/system/index")
public class IndexController {
    @Autowired
    private SysUserService sysUserService;

    @Operation(summary = "登录", description = "登录")
    @PostMapping("login")
    public Result<Login> login(@RequestBody LoginVo loginVo) {
        Login login = sysUserService.login(loginVo);
        return Result.success(login);
    }

    @Operation(summary = "获取用户信息", description = "获取用户信息")
    @GetMapping("info")
    public Result<SysUserinfo> info(HttpServletRequest request) {
        SysUserinfo userinfo = sysUserService.getUserinfo(request);
        return Result.success(userinfo);
    }

    @Operation(summary = "退出", description = "退出")
    @PostMapping("logout")
    public Result<Map<String, Object>> logout() {
        return Result.success();
    }
}