package com.atguigu.auth.service;

import com.atguigu.model.system.Login;
import com.atguigu.model.system.SysUser;
import com.atguigu.model.system.SysUserinfo;
import com.atguigu.vo.system.LoginVo;
import com.atguigu.vo.system.SysUserQueryVo;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;

import javax.servlet.http.HttpServletRequest;

/**
 * <p>
 * 用户表 服务类
 * </p>
 *
 * @author bunny
 * @since 2024-04-22
 */
public interface SysUserService extends IService<SysUser> {

    /**
     * 用户条件分页查询
     *
     * @param page  当前页
     * @param limit 每页记录数
     * @param vo    查询条件
     * @return 分页结果
     */
    IPage<SysUser> getUserByPage(Long page, Long limit, SysUserQueryVo vo);

    /**
     * 更新状态
     *
     * @param id     用户id
     * @param status 修改的状态
     */
    void updateStatus(Long id, Long status);

    /**
     * 登录
     *
     * @param vo 登录条件
     * @return 返回token
     */
    Login login(LoginVo vo);

    /**
     * 获取用户信息
     *
     * @param request 请求头
     * @return 用户信息
     */
    SysUserinfo getUserinfo(HttpServletRequest request);

    /**
     * 根据用户名查询用户信息
     *
     * @param username 用户名
     * @return 用户信息
     */
    SysUser getByUsername(String username);
}
